class Creature implements Silence {
  //declaring the Dna
  DNA dna;
  // declaring the creatures with which the creature will interact
  Creature friend, neighbour, partner;

  // this will store a story of the children of each creature
  ChildCreature child;
  ArrayList <ChildCreature> myChild;

  // voice variables
  Voice voice;
  Oscil carrier, childModul;
  Frequency voiceFreq;
  float amp;

  //physics and spatial
  PVector location;
  float x, y, z;
  float edgex, edgey;
  PVector velocity, accel, newAccel;
  float velx, vely;
  float theta, steeringForce, count, rotation, angle, halfAngle;
  float speedx, speedy, maxSpeed;
  float wandertheta;



  //physical attributes
  int sides;
  int minSides, maxSides;
  color skin;
  float radius, outRad, innerRad;
  float headx, heady;

  // voice and etnicity - this is considered as a language mostly.
  String etnicity;
  String [] myEtnicity = {
    "A", "B", "C", "D", "E", "F", "G"
  };

  //index of each creature
  String index;

  // some boolean
  boolean alive;
  boolean moving, collide;
  boolean coupled;
  boolean sexmatch, fitnessmatch, agematch, skinmatch, etnicmatch;

  //ints vars to store the creature history
  int numFriends, numPartners, numChildren, numNeighbours;

  /*------------------------------------------------*/

  Creature() {

    //physical
    dna = new DNA();
    myChild = new ArrayList <ChildCreature>();
    etnicity = myEtnicity[(int)random(0, myEtnicity.length)];

    //physical attributes
    minSides = 3; //min num sides first generation
    maxSides = 19; //max num sides first generation
    sides = (int)abs(randomGaussian()*(noise(minSides, maxSides)*random(minSides, maxSides))); //this should set the average num side from min to max
    if (sides<=2) {
      sides=minSides; //if num sides <=2 let's make the num sides  = 3
    }
    
    radius = random(5, 40);
    outRad = radius/cos(TWO_PI / sides);
    innerRad = radius/2;
    
    if (dna.mutation<=2) {
      skin = color (random(255), random(255), random(255));// here I am creating an exception in skin. If the mutation val is =<2 then the skin will be random.
    } else {
      //otherwise crete skin
      
      String colorStr ="" + etnicity + str(int(radius)) + str(sides) + str(int(dna.mutation));
      println ("-----mio colore stringa " + colorStr + " - " + str(colorStr.length()));
      
      if (colorStr.length()%2 == 0){
      colorStr = colorStr + etnicity;
//      skin = color (unhex(colorStr));// range of orange color

      } else {
      
      skin = color (random(255), random(255), random(255));// here I am creating an exception in skin. If the mutation val is =<2 then the skin will be random.

      }      
      
    }
          println ("-----mio colore vero " + str(skin));


    //physics
    accel = new PVector(0, 0);
    velx = randomGaussian();
    vely = randomGaussian();
    velocity = new PVector(velx, vely);
    maxSpeed = sqrt(radius);
    //    fast=false;
    wandertheta = 0;
    steeringForce = maxSpeed/(radius*sides*dna.mutation);

    //spatial
    x = random(radius*4, width - radius*4);
    y = random(radius*4, height - radius*4);
    location = new PVector(x, y);
    edgex = x-radius;
    edgey = y-radius;

    //boolean
    coupled = false;
    collide = false;
    sexmatch = false;
    fitnessmatch = false;
    agematch = false;
    skinmatch = false;
    etnicmatch = false;
    alive = true;

    index = "0";

    //historic
    numChildren = 0;
    numFriends = 0;
    numPartners = 0;
    numNeighbours = 0;
    child = null;
    friend = null;
    partner = null;
    neighbour = null;
    childModul = null;

    //voice

    int freqLimit = (int)map(random(sides-dna.mutation), 0, 100, 4, 8 ); //limiting the freq
    amp = map (dna.lifespan, 1, 3000, 0.0, 0.1); //defining the amp according to the lifespan

    //conditioning the single Oscillator to the lenght of the etnicity
    if (etnicity.length()<2) {
      carrier = new Oscil( Frequency.ofPitch(etnicity+Integer.toString(freqLimit)), amp, Waves.SINE );
      //        carrier = new Oscil( Frequency.ofPitch(etnicity+Integer.toString(int(random(sides-dna.mutation)))), 0.8, Waves.TRIANGLE ); // old version
      //    childModul = new Oscil( Frequency.ofPitch(etnicity+Integer.toString(int(random(sides-dna.mutation)))), 0.0, Waves.TRIANGLE );  // possible for fm modulation
    }    
    voice = new Voice(carrier);
    talk(); //make them talk!
  }

  /*--------------RUN--------------------*/

  void run() {
    update();
    borders();
    display();
  }

  /*----------------UPDATE-----------------*/

  void update() {

    dna.lifespan--; //reducing lifespan every cycle
    checkLife(); //check if the creature is alive
    // Update velocity
    velocity.add(accel);
    // Limit speed
    velocity.limit(maxSpeed);
    location.add(velocity);
    // Reset accelerationelertion to 0 each cycle
    accel.mult(0);
    //voice
    //    modulate(childModul);
    amp = map (dna.lifespan, 1, 3000, 0.0, 0.5);
    setAmp(amp);

    //silencing the creatures if they are dead - R.I.P.
    if (dna.lifespan<=0) {
      silence();
    }

    //testing the encapsulaiton of the procreation in the creature itself.
    //procreation
    //    if (coupled) {
    //      procreate();
    //    }
  }

  /*----------------CHECK LIFE OF THE CREATURE-----------------*/

  // checkLife checks all the variations in the creature life e.g. lifespan and partners and children and potentially neighbours.
  void checkLife() {
    // Check lifespan
    if (dna.lifespan<=0) {
      silence();
      dna.lifespan=0;
      alive=false;
    }

    //check partner
    //TODO
    //check children
    //TODO
    //check neigbours
  }


  /*--------------DISPLAY--------------------*/

  /*here is the function that determins the way creatures look 
   males are fully colored polygons
   females are empty colored (just borders) polygons
   herma (not used in this sketch) have both border and full color
   the gender doesn't affect the way creatures look
   
   */

  void display() {
    theta = velocity.heading2D();
    angle = TWO_PI / sides;
    halfAngle = angle/2.0+sin(theta);

    if (alive==true) {
      if (dna.sex== "male") {
        pushStyle();
        fill(skin);
        noStroke();
        beginShape();
        for (float a = 0; a < TWO_PI; a += angle) {
          float xp = location.x + cos(theta+a) * radius;
          float yp = location.y + sin(theta+a) * radius;
          vertex(xp, yp);
          ellipse(xp,yp, radius/dna.lifespan,radius/dna.lifespan); //little circles explode at death
          
          pushStyle();
          fill(red(skin),green(skin),blue(skin),255/sides);
          ellipse(xp,yp, dna.lifespan/(radius*sides),dna.lifespan/(radius*sides)); //little hands
          popStyle();
          xp = location.x + cos(theta+a+halfAngle) * innerRad;         //theta is the value which will affect the shape - take theta out and yo'll get just a normal polygon
          yp = location.y + sin(theta+a+halfAngle) * innerRad;
          vertex(xp, yp);
        }
        displayHead();
        endShape(CLOSE);
//        ellipse(location.x, location.y,20,20);
        popStyle();

        displayOutRadius();
        displayIndex();
      }
      if (dna.sex== "female") {
        pushStyle();
        noFill();
        stroke(skin);
        strokeWeight(random(.5, 1));
        beginShape();
        for (float a = 0; a < TWO_PI; a += angle) {
          float xp = location.x + cos(theta+a) * radius;
          float yp = location.y + sin(theta+a) * radius;
          vertex(xp, yp);
          ellipse(xp,yp, radius/dna.lifespan,radius/dna.lifespan); //little circle explode at death

          line(xp,yp,location.x, location.y);
          xp = location.x + cos(a+halfAngle) * innerRad;
          yp = location.y + sin(a+halfAngle) * innerRad;
          vertex(xp, yp);
        }
        displayHead();
        endShape(CLOSE);
        popStyle();

        displayOutRadius();
        displayIndex();
      }    

      if (dna.sex== "herma") {
        pushStyle();
        fill(skin);
        stroke(skin);
        strokeWeight(random(.5, 1));
        beginShape();
       for (float a = 0; a < TWO_PI; a += angle) {
          float xp = location.x + cos(theta+a) * radius;
          float yp = location.y + sin(theta+a) * radius;
          vertex(xp, yp);
          xp = location.x + cos(theta+a+halfAngle) * innerRad;
          yp = location.y + sin(theta+a+halfAngle) * innerRad;
          vertex(xp, yp);
        }
        displayHead();
        endShape(CLOSE);
        popStyle();

        displayOutRadius();
        displayIndex();
      }
    }
  }


  /*----------------POLYGON STAR-----------------------*/

  void createPoly(float x, float y, float radius, float innerRad) {

    int sides = (int)random(19); 
    color skin = color (random(255), random(255), random(255));
    float theta = random(360%45);
    float angle = TWO_PI / sides;
    float halfAngle = angle/2.0;
    pushStyle();
    fill(skin);
    noStroke();
    beginShape();
    for (float a = 0; a < TWO_PI; a += angle) {
      float sx = x + cos(a) * radius;
      float sy = y + sin(a) * radius;
      vertex(sx, sy);
      sx = x + cos(a+halfAngle) * innerRad;
      sy = y + sin(a+halfAngle) * innerRad;
      vertex(sx, sy);
    }
    endShape(CLOSE);
    popStyle();
    popMatrix();
  }



  /*----------------MOVE-----------------------*/

  void move() {
    moving = true;
    float wanderR = radius;         // Radius for our "wander circle"
    float wanderD = radius*sides;         // Distance for our "wander circle"
    float change = 0.3;
    wandertheta += random(-change, change);     // Randomly change wander theta

    // Now we have to calculate the new location to steer towards on the wander circle
    PVector circleloc = velocity.get();    // Start with velocity
    circleloc.normalize();            // Normalize to get heading
    circleloc.mult(wanderD);          // Multiply by distance
    circleloc.add(location);               // Make it relative to boid's location

      float h = velocity.heading2D();        // We need to know the heading to offset wandertheta

    PVector circleOffSet = new PVector(wanderR*cos(wandertheta+h), wanderR*sin(wandertheta+h));
    PVector target = PVector.add(circleloc, circleOffSet);
    seek(target);

    // Render wandering circle, etc. 
    if (debug) drawWanderStuff(location, circleloc, target, wanderR);
  }

  /*----------------SEEK-----------------------*/

  void seek(PVector target) {
    PVector desired = PVector.sub(target, location);  // A vector pointing from the location to the target

    // Normalize desired and scale to maximum speed
    desired.normalize();
    desired.mult(maxSpeed);
    // Steering = Desired minus Velocity
    PVector steer = PVector.sub(desired, velocity);
    steer.limit(steeringForce);  // Limit to maximum steering force
    applyForce(steer);
  }

  /*----------------FORCES-----------------*/


  void applyForce(PVector force) {

    if (!fast) {
      // We could add mass here if we want A = F / M
      //mass is num sides + radius
      force = PVector.div(force, (radius*sides));//this is the vector you need to make the mass working
      accel.add(force); //comment this and uncomment the two lines below if you want the mass working
    } else {
      accel.add(force); //comment this and uncomment the two lines below if you want the mass working
    }
  }

  /*----------------FREEZE-----------------------*/

  void freeze() {

    //    theta+= speedx/10;
    PVector velZero = new PVector(0, 0);
    setVel(velZero);

    //uncomment these 2 lines if you want the creatures to stop completely!
    //    steeringForce=0;
    //    theta=0;
  }


  /*----------------COLLISION-----------------------*/
  boolean colliding(Creature c) {

    float distance = location.dist(c.location)  ;
    if (distance <= radius + c.radius  ) { //if collide
      collide=true; //collide true
      numPartners++;  //increase num partners
      return true;
    } else {
      collide=false;
      return false;
    }
  }

  /*----------------TALK-----------------*/


  void talk() {
    // voice
    carrier.patch (voice.out);
  }

  /*----------------silence-----------------*/


  void silence() {
    carrier.unpatch(voice.out);
    //    childModul.unpatch(voice.out);
  }


  /*---------------set NEW VOICE---------------------*/

  void setThisVoice() {
    //TODO
  }



  /*---------------MODULATE OSCIL ---------------------*/

  //this is a work in progress ti implement the fm modulation
  /*
  void modulate(Oscil wave)
   {
   float freq = map( location.x+1, 0, width, 20, 880 );
   float amp = map( location.y+1, 0, height, .5, 0 );
   float modulateAmount = map( mouseY, 0, height, 220, 1 );
   float modulateFrequency = map( mouseX, 0, width, 0.1, 100 );
   
   wave.setFrequency( freq );
   wave.setAmplitude( amp );
   }
   */

  /*----------------PROCREATE-----------------*/
  // this was an old attempt. didn't work - I wanted to encapsulate the procreation into the creature.
  /*
      void procreate() {
   child = new ChildCreature();
   child.setParents(this, partner);
   child.setDNA();
   myChild.add(child); // adding the child to the vector
   }
   
   */

  /*----------------stage wrapping-----------------*/

  // Wraparound the stage -  creatures will go from side to side
  void borders() {
    if (location.x < -radius) location.x = width;
    if (location.y < -radius) location.y = height;
    if (location.x > width) location.x = -radius;
    if (location.y > height) location.y = -radius;
  }


  /*-------------this is the edge of the creature--------------*/

  float borderX() {

    return edgex;
  }

  float borderY() {

    return edgey;
  }

  /*------------AREA-------------*/
  //eventually to calculate the area of the creature
  float area() {
    return (pow(radius, sides)*sin(PI/sides))/2;
  }

  /*---------------limit function ---------------------*/

  /*
    ////// limit function/////quick fucntion that allows me to limit some value;
   
   private int intoRange(int value, int min, int max) {
   return Math.min(Math.max(value, min), max);
   }
   */

  /*-----------DEBUG-----------------*/

  //inf on index, location and velocity
  void displayIndex() {
    if (debug) {

      fill(0, 200, 200);
      textSize(radius+10);
      text(index+"/ "+str(theta), location.x, location.y);

      fill(0, 100, 200);
      textSize(13);
      text("velocity "+str(velocity.x*velocity.y), location.x+radius, location.y+10);
      text("maxSpeed "+str(maxSpeed), location.x+radius, location.y+20);
      text("mass "+str(fast), location.x+radius, location.y+30);
      //      text("num child "+str(child), location.x+radius, location.y+40);
    }
  }


  /*---------------some fancy debug of physical attribute you don't really need-------------*/


  void displayOutRadius() {
    if (debug) {
      noFill();
      //    ellipse(x, y, outRad, outRad);
      stroke(160);
      ellipse(location.x, location.y, radius*2+(radius/4), radius*2+(radius/4));
    }
  }


  void displayHead() {
    if (head) {
      headx = location.x + cos(theta + TWO_PI / sides) * radius;
      heady = location.y + sin(theta + TWO_PI / sides) * radius;
      ellipse(headx, heady, 8, 8);
    }
  }


  /*-------------  setters & getters  -------------*/


  //setters
  void setX(float xPos) {

    location.x = xPos;
  }
  void setY(float yPos) {

    location.y = yPos;
  }

  void setLoc(PVector newLocation) {

    location = newLocation;
  }

  void setVel(PVector newVelocity) {

    velocity = newVelocity;
  }

  void setAccel(PVector acceleration) {

    accel = acceleration;
  }

  /// set partner, friend, neighbour

  void setFriend(Creature f) {

    friend = f;
  }

  void setPartner(Creature p) {

    partner = p;
  }

  void setNeighbour(Creature n) {

    neighbour = n;
  }


  //set physical stuff: sides, skin, radius, etnicity

  void setSides(int n) {

    sides = n;
  }

  void setSkin(color newColor) {

    skin = newColor;
  }

  void setRadius(float rad) {

    radius = rad;
  }

  void setEtnicity(String newEtn) {

    etnicity = newEtn;
  }

  void setAmp(float a) {

    amp = a;
  }




  ////////////getters


  float getX() {

    return location.x;
  }
  float getY() {

    return location.y;
  }
  float getVelx() {

    return velocity.x;
  }
  float getVely() {

    return velocity.y;
  }
  PVector getAccel() {

    return accel;
  }


  /// //get physical stuff: sides, skin, radius, etnicity

  int getSides() {

    return sides;
  }

  color getSkin() {

    return skin;
  }

  float getRadius() {

    return radius;
  }

  String setEtnicity() {

    return etnicity;
  }
}