import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import ddf.minim.*; 
import ddf.minim.ugens.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class manymals_Master_v02 extends PApplet {

/*
//================================================================================================================================================//
 //==================================================== M A N Y M A L S  V.02 ====================================================================//
 //================================================================================================================================================//
 //Author: 
 //Antonio Daniele
 //EXPLORING SOCIAL BEHAVIOUR AND IDENTITY THROUGH GENETIC ALGORITHMS.
 //End of term assignment: Programming for Artists ::: MFA Computational arts 2014 -15
 
 ////////////////////////////////////////////////////////////////////////
 
 Aim
 ---
 The aim is to experiment with genetic algorithms in order to explore the possibilities of relations between creatures that simulate a behaviour.
 The work is also a way for me to engage with some more advanced Java and generative systems.
 This work is meant to be a starting point for exploring these subjects.
 
 Process
 -------
 I started, as usual, from a vision, an image that I had in mind.
 At first I approached this project with almost no notions of genetic algorithms. I wanted to see if I could get my own way by using some logic.
 In fact, probably, this project doesn't use the common variables of GA (fitness, mutation etc) as many other projects use.
 My idea was mostly to rely on my logic leaving open the possibility to explore different variations.
 Once I set up the core of the program I started reading some documents on GA and checked other examples that I confrontated with mine.
 I noticed that more or less the approach was similar and I then optimised my code according to what was more useful.
 For instance, after my first attempts on moving the creatures, although good, they were eventually highly influented by the Shiffman's
 Nature of code examples on vector forces. 
 This is the only part of code that Is not completely original. Together with the function to create polygons, by knowing the radius.
 The rest of the code is from my own head and there are evident margins for improvements.
 In few words the process I followed was sticking to the main image that I had in mind according to which the creatures had to represent human individuals
 and simulating some sort of social behaviour. And of course procreating.
 I always imagined these creatures with the ability of 'speaking'. In fact in my idea the sound they produce is a proper language based on their place of birth (etnicity var).
 The language evolves with the creatures so that when they pass 1 generation they can start producing a sequence of notes rather than a single pronlonged sound.
 
 The code counts 3 main classes
 DNA - that contains the basic data of the creature (sex, gender, lifespan and mutation)
 Creature - this is the basic creature which contains the physical features, behaviour and voice
 ChildCreature - this is a child class of Creature. The choice of having a subclass is because I wanted the child to have different features like the language.
 
 The class Voice is an easier way to call the minim library.
 Finally, SIlence is a work in progress Interface that I would like to use in a future development.
 
 
 Comments
 --------
 The program is working well and as expected.
 I managed to create a good variety of possibilities for language and populations.
 There are massive margins of improvement for this code.
 Not only from an aesthetic point of view but also for efficiency and functionalities.
 I would like to port this on a mobile app or a web app for instance.
 Overall I think I am happy with this project as I acheived the pre-fixed results and overcame many issues
 such as the good implementation of the sound (which caused many problems) or controlling the birth of new children.
 
 At the moment the project is in a very beta phase. It is all very experimental.
 For instance the "etnicity" variable has been strongly discussed as it involves some idea that extends the language. Etnies are more than just language and in fact this
 is something that I would like to introduce in a further version. Maybe the possibilities to create different behaviours according to "cultures".
 Same it can be said for the gender and sex dynamics.
 At the moment the creatures reproduce following the main matingRules(). However I would like to condition  the creatures' mating behaviour according to factors such as
 the fitness or the etnicity value or other social variables like prejudice etc.
 
 Evaluation
 ----------
 Bugs: Very rarely the sound keeps on going even after the death of all the animals. This usually happens when there are a lot of repeted press of letter 'r'.
 I didn't find a way to kill the sound for good, so I had to condition that to the amplitude and the lifespan. 
 Extensions:None
 
 Keybord Commands
 ----------
 r       - reset and repopulate the universe
 d       - debug info 
 l       - if debug info activated, it shows the construction lines of the movement forces
 f       - speeds up the creatures or slow them down. It actually gives the creatures a mass. (if the creature is fast already this will affect the child)
 s       - save a screenshot
 
 
 Pseudocode
 ----------
 Here after there is a pseudocode for one of the main functions of the program. I am not going to explain the matingRules() method as it is just long and boring.
 I think the process to build sex and gender is more fun. It is in the DNA class.
 
 Aim is getting out a random gender for each creature. The gender is determined by calculating 4 random percentage up to 100%.
 The higher value will be the determined gender. The same applies to sex. This choice is a conceptual choice as well as practical.
 Creatures like us are neither 100% male or female, they have a dynamic balance of these values.
 
 1st part - distribute 100 in 4 boxes.
 1 - I create an array1 of String with n elements. One for each gender/sex
 2 - I create an array2  of Int with the same num of elements of the String array. The elements here have value 0;
 3 - I then need to have 2 variables. 1 String var to store the value of the final gender/sex.
 4 - The other variable is an Int and will store the index of the array with higher percentage. 
 5 - let's randomly distribute the number 100 in 4 elements of the array2 (int)
 6 - create a for loop which iterates through the random elements of the array2. and adds 1 unit.
 in this way 100 units will be distributed randomly in the 4 elements of the array.
 
 2nd part - find the largest number in the array and get me the index of that element in the array.
 7 - take the first element and store it into a var called largest
 8 - iterate all the elements in the array (go from 1 to array.length to avoid exceeding)
 9 - if the second element is higher than the first then it become "largest"
 10 - proceed like this for all the elements (for loop)
 11 - once found the largest number in the array, give me back the index (that will be the int i of the for loop) 
 
 3rd part 
 12 - assign the index just found to determin the sex/gender in the String array1
 
 
 
 */

//================================================================================================================================================//
//==================================================== M A N Y M A L S  V.00 ====================================================================//
//================================================================================================================================================//


// import everything necessary to make sound. (Minim Library)




/*-----------GLOBAL VARIABLES-----------------*/

int numCreatures; //initial num of creatures in the Universe

//boolean collide, sexmatch, fitnessmatch, agematch, skinmatch, etnicmatch; //TODO
ArrayList <Creature> myCreatures;
boolean debug, vectorLines = false;
boolean head, fast = true;
boolean startTouch, endTouch;
int touchcount;  //counter
int divider = 0;  // used to control the num of touch. obsolete now.
//Silence silence; // Test for interface

//save image vars//
int imageCounter=0;
int d = day();    // Values from 1 - 31
int m = month();  // Values from 1 - 12
int y = year();   // 2003, 2004, 2005, etc.
int sec = second();  // Values from 0 - 59
int min = minute();  // Values from 0 - 59
int h = hour();    // Values from 0 - 23
//end save image vars//

/*-----------SETUP-----------------*/


public void setup() {
  
 //use random seed to generate always the same sequence
//  randomSeed(150);

  startTouch = false;
  endTouch = false;
  touchcount = 0;
  numCreatures = 7*2;
  
  
  
  CreatureSetup();
}

/*-----------DRAW-----------------*/


public void draw() {

  //use random seed to generate always the same sequence
//  randomSeed(150);

  background(250);
  //println(myCreatures.length);
  populate();
  checkContact();

  //when there are no creatures there is a message;
  restartMessage();
}



/*-----------CHECK CONTACT-----------------*/

public void checkContact() {
  //iterating the creatures like in a matrix
Outer:
  for (int i = 0; i < myCreatures.size (); i++)  
  {  
    for (int j = i + 1; j < myCreatures.size (); j++)  
    {  
      if (myCreatures.get(i).colliding(myCreatures.get(j)) && myCreatures.get(j).colliding(myCreatures.get(i)) ) {

        /* this block is a work in progress to create more social behaviour.
         WHen the creatures first meet they become friends. If they stay for long enough become partners and then they reproduce. 
         at the moment it is not working properly. Need some job on it.
         
         myCreatures.get(i).setFriend(myCreatures.get(j));
         myCreatures.get(j).setFriend(myCreatures.get(i));
         
         if (myCreatures.get(i).collide==true) {
         myCreatures.get(i).numFriends++;
         myCreatures.get(j).numFriends++;
         }
         
         if (myCreatures.get(i).numFriends>=myCreatures.get(i).dna.timeMating) {
         myCreatures.get(i).numFriends=0;
         myCreatures.get(i).numPartners++;
         myCreatures.get(j).numPartners++;
         }
         */

        //now check the mating Rules
        matingRules();
        break Outer;
      }
    }
  }
}




/*------------POPULATE------------------*/


public void populate() {

  for (int i = 0; i<myCreatures.size (); i++) {

    myCreatures.get(i).run();
    myCreatures.get(i).move();
    myCreatures.get(i).index=str(i);

    //when they are dead just remove them from the list
    if (myCreatures.get(i).alive==false) {
      myCreatures.remove(i);
    }
  }
}

/*------------CREATURE SETUP------------------*/

public void CreatureSetup() {
  myCreatures = new ArrayList <Creature>();
  for (int i = 0; i<numCreatures; i++) {

    myCreatures.add (new Creature()); // creating all the creatures

    println( myCreatures.get(i).dna.sex, myCreatures.get(i).dna.gender, myCreatures.get(i).etnicity, myCreatures.get(i).dna.lifespan, i);
  }
}

/*------------CREATURE KILL ALL------------------*/

public void killAll() {
  for (int i = 0; i<myCreatures.size (); i++) {
    myCreatures.get(i).silence(); //silencing all the creatures

    println( "new size is "+ myCreatures.size());
  }

  myCreatures.clear();
}

/*--------------- MATING RULES ---------------------*/
//this is the main function that determins which creatures can meet and eventually reproduce according to sex and gender.
public void matingRules() {
Outer:
  for (Creature one : myCreatures) {
    one.sexmatch = false;
    for (Creature other : myCreatures) {
      if (one != other && one != one.child && other != other.child && one.colliding(other) && other.colliding(one)) {
        if (  //start mega IF

        //hetero//
        (one.dna.sex=="male" && one.dna.gender=="hetero") && (other.dna.sex=="female" && other.dna.gender=="hetero") ||

          //homo male//
        (one.dna.sex=="male" && one.dna.gender=="homo") && (other.dna.sex=="male" && other.dna.gender=="homo") ||
          (one.dna.sex=="male" && one.dna.gender=="homo") && (other.dna.sex=="male" && other.dna.gender=="bi") ||
          (one.dna.sex=="male" && one.dna.gender=="homo") && (other.dna.sex=="male" && other.dna.gender=="trans") ||
          //homo female//
        (one.dna.sex=="female" && one.dna.gender=="homo") && (other.dna.sex=="female" && other.dna.gender=="homo") ||
          (one.dna.sex=="female" && one.dna.gender=="homo") && (other.dna.sex=="female" && other.dna.gender=="bi") ||
          (one.dna.sex=="female" && one.dna.gender=="homo") && (other.dna.sex=="female" && other.dna.gender=="trans") ||

          //trans male//
        (one.dna.sex=="male" && one.dna.gender=="trans") && (other.dna.sex=="male" && other.dna.gender=="trans") ||
          (one.dna.sex=="male" && one.dna.gender=="trans") && (other.dna.sex=="female" && other.dna.gender=="trans") ||
          (one.dna.sex=="male" && one.dna.gender=="trans") && (other.dna.sex=="male" && other.dna.gender=="bi") ||
          (one.dna.sex=="male" && one.dna.gender=="trans") && (other.dna.sex=="male" && other.dna.gender=="homo") ||
          //trans female//
        (one.dna.sex=="female" && one.dna.gender=="trans") && (other.dna.sex=="female" && other.dna.gender=="trans") ||
          (one.dna.sex=="female" && one.dna.gender=="trans") && (other.dna.sex=="male" && other.dna.gender=="trans") ||
          (one.dna.sex=="female" && one.dna.gender=="trans") && (other.dna.sex=="female" && other.dna.gender=="bi") ||
          (one.dna.sex=="female" && one.dna.gender=="trans") && (other.dna.sex=="female" && other.dna.gender=="homo") ||

          //bi male//
        (one.dna.sex=="male" && one.dna.gender=="bi") && (other.dna.sex=="male" && other.dna.gender=="bi") ||
          (one.dna.sex=="male" && one.dna.gender=="bi") && (other.dna.sex=="male" && other.dna.gender=="homo") ||
          (one.dna.sex=="male" && one.dna.gender=="bi") && (other.dna.sex=="female" && other.dna.gender=="hetero") ||
          (one.dna.sex=="male" && one.dna.gender=="bi") && (other.dna.sex=="female" && other.dna.gender=="bi") ||
          (one.dna.sex=="male" && one.dna.gender=="bi") && (other.dna.sex=="male" && other.dna.gender=="trans") ||
          //bi female//
        (one.dna.sex=="female" && one.dna.gender=="bi") && (other.dna.sex=="female" && other.dna.gender=="bi") ||
          (one.dna.sex=="female" && one.dna.gender=="bi") && (other.dna.sex=="female" && other.dna.gender=="homo") ||
          (one.dna.sex=="female" && one.dna.gender=="bi") && (other.dna.sex=="male" && other.dna.gender=="hetero") ||
          (one.dna.sex=="female" && one.dna.gender=="bi") && (other.dna.sex=="male" && other.dna.gender=="bi") ||
          (one.dna.sex=="female" && one.dna.gender=="bi") && (other.dna.sex=="female" && other.dna.gender=="trans") 



        ) { //end mega IF ---->

          //setting sexmatch
          one.sexmatch = true;
          other.sexmatch = true;
          //setting coupled
          one.coupled = true;
          other.coupled = true;

          //the creatures stop and start knowing each other
          one.freeze();
          other.freeze();

          //debug info on the meeting (press key 'd')
          matingInfo();

          //limiting the procreation to timing conditioned by the dna
          if (one.numPartners%one.dna.timeMating==0 || other.numPartners%other.dna.timeMating==0 ) {
            //setting partners
            one.setPartner(other);
            other.setPartner(one);
            //finally procreate
            procreate(one, other);
          }
          break Outer;
        }
      }
    }
  }
}

/*--------------- MATING INFO (debug) ---------------------*/


public void matingInfo() {

  if (debug) {
    for (Creature one : myCreatures) {
      for (Creature other : myCreatures) {
        if (one != other && one.colliding(other)) {

          //display info on stage//
          pushMatrix();
          int rectCoord = 120;
          translate(0, height-rectCoord);
          fill(255, 255, 255);
          noStroke();
          rect(0, 30, width, rectCoord);
          fill(0, 100, 200);
          textSize(12);
          String oneInfo = (one.dna.sex + " " + one.dna.gender + " " + one.etnicity);
          text(oneInfo, 10, 50);
          text("meets", 10, 70);
          String otherInfo = (other.dna.sex + " " + other.dna.gender + " " + other.etnicity);
          text(otherInfo, 10, 90);
          popMatrix();

          //println
          //        println("touchcount " + touchcount);
          //        println("sexmatch!");
          //        print (one.dna.sex, one.dna.gender, one.etnicity);
          //        print (" meets ");
          //        println(other.dna.sex, other.dna.gender, other.etnicity);
        }
      }
    }
  }
}

/*---------------PROCREATE---------------------*/
//this function procreates the new creatures.
public void procreate( Creature parent1, Creature parent2) {

  ChildCreature child;
  child = new ChildCreature(parent1, parent2);

  myCreatures.add (child); // creating all the creatures
  parent1.myChild.add (child); // adding to the list of the parent 1 child
  parent2.myChild.add (child); // adding to the list of the parent 1 child
}



/*------------KEY COMMANDS-------------------*/


public void  keyPressed() {

  //reset
  if (key == 'r') {
    killAll();
//    CreatureSetup();
//    populate();
  }

  //debug
  if (key == 'd') {
    debug = !debug;
  }

  //display head
  if (key == 'h') {
    head = !head;
  }

  //display vector debug -- it workg sonly with debug activated
  if (key == 'l') {
    vectorLines = !vectorLines;
  }

  // trigger the speed of the creatures (according to their mass)
  if (key == 'f') {
    fast=!fast;
  }


  //saving files
  if (key == 's' ) {
    imageCounter+=1;
    save("screenshots_"+d+m+y+"/manymals_"+imageCounter +"_"+d+m+h+min+sec + ".jpg");
  }
}

public void keyReleased(){
  if (key == 'r') {
    killAll();
    CreatureSetup();
    populate();
  }

}

/*------------restart Message-------------------*/


public void restartMessage() {
  //restart message at the end of the game
  if (myCreatures.size()<=0) {
    fill(0, 0, 0, 30);
    noStroke();
    randomPolygon(width/2, height/2, random(50), (int)random(10));

    fill(0);
    textSize(13);
    String introMess = "press r to populate the universe!";
    text(introMess, width/2 - textWidth(introMess)/2, height/2);
  }
}

public void randomPolygon(float x, float y, float radius, int npoints) {
  float angle = TWO_PI / npoints;
  beginShape();
  for (float a = 0; a < TWO_PI; a += angle) {
    float sx = x + cos(a) * radius;
    float sy = y + sin(a) * radius;
    vertex(sx, sy);
  }
  endShape(CLOSE);
}


/*------------DEBUG info-------------------*/


public void printData() {

  //  println( myCreatures[i].dna.sex, myCreatures[i].sides, 
  //  myCreatures[i].dna.gender, myCreatures[i].dna.etnicity, 
  //  "area", myCreatures[i].area());
  for (int i = 0; i<myCreatures.size (); i++) {

    print( myCreatures.get(i).dna.sex + " ");
    print( myCreatures.get(i).dna.gender + " ");
    print( myCreatures.get(i).etnicity + " ");

    //  print( myCreatures[i].sides + " ");
    //  print( myCreatures[i].radius + " ");
    //  print( myCreatures[i].index + " ");
    //  print( myCreatures[i].area + " ");
  }
}

// A method just to draw the circle associated with wandering
public void drawWanderStuff(PVector location, PVector circle, PVector target, float rad) {
  if (vectorLines) {
    stroke(0); 
    noFill();
    ellipseMode(CENTER);
    ellipse(circle.x, circle.y, rad*2, rad*2);
    ellipse(target.x, target.y, 4, 4);
    line(location.x, location.y, circle.x, circle.y);
    line(circle.x, circle.y, target.x, target.y);
  }
  displayInfo();
}


public void displayInfo() {

  for (int i = 0; i<myCreatures.size (); i++) {

    if (debug) {
      fill(0, 100, 200);
      textSize(13);
      String info = (myCreatures.get(i).dna.sex + " "
        + myCreatures.get(i).dna.gender + " "
        + myCreatures.get(i).etnicity + " "
        + "lifespan " + myCreatures.get(i).dna.lifespan  + ", "
        + "mutation " + myCreatures.get(i).dna.mutation  + ", "

        //        + myCreatures.get(i).alive  + ", "
      //      + "friends " + myCreatures.get(i).numFriends  + ", "
      + "partners " + myCreatures.get(i).numPartners  + ", "
        //      + myCreatures.get(i).dna.mySexPerc[0] + ", "
      //      + myCreatures.get(i).dna.mySexPerc[1] + ", "
      + "amp " + myCreatures.get(i).amp + ", " //amplitude of the Oscil
      + "index " + str(i)); //index of the  creature in the arraylist

      text(info, 10, 20+20*i);
      println( );
    }
  }
}
public class ChildCreature extends Creature implements Silence {

  DNA dna;
  Creature parent1, parent2;
  //  Oscil childModul, childCarrier;
  int sexPercMale, sexPercFem;  

  //to define the DNA of the child I will take the relative values of the sex from the parents DNA and sum them.
  //The higher value will be the sex of the child

  /*---------------CONSTRUCTOR---------------------*/

  ChildCreature( Creature pa1, Creature pa2) {

    println("--------------- NEW CHILD");
    parent1 = pa1;
    parent2 = pa2;
    //create a new DNA
    dna = new DNA();
    //setting the new  dna and physical parameters
    setDNA();
    setPhysical();
    setX(pa2.location.x + pa2.radius);
    setY(pa2.location.y + pa2.radius);


    //setting the new voice of the child
    setThisVoice();
    talk();
  }

  /*---------------RUN ---------------------*/

  /*
  void run() {
   //   super.run();
   modulate(childModul);//fucntion for the modulation of the fm
   } 
   */

  /*---------------set DNA---------------------*/

  public void setDNA() {
    //    setParents(parent1, parent2);
    //defining the new sex
    defineChildSex();
    //setting the new sex percentage
    dna.setSexPerc(sexPercMale, sexPercFem);
    //    dna.defineGender();
    //setting the gender

    //we don't need these as it is already generated in the DNA
    //    dna.gender = dna.myGender[dna.genderType];
    //    //setting lifespan
    //    dna.lifespan = int(random(1, (30*100)));
  }


  /*---------------set PHYSICAL ATTR.---------------------*/

  public void setPhysical() {

    //skin color
    float r, g, b;
    r = (red(parent1.skin))-(sides+dna.mutation);
    g = (green(parent2.skin))+(sides+dna.mutation);
    b = ((blue(parent1.skin)) + (blue(parent2.skin)))/(2);

    if (dna.mutation<=2) {
      skin = color (random(255), random(255), random(255));// here I am creating an exception in skin. If the mutation val is =<2 then the skin will be random.
    } else {
      //otherwise create skin with this rule
      skin = color ( r, g, b);// 
      //    skin = color ( 0, 255, 0);// full green used to test
      //    setSkin(skin);
    }
    //sides are a combination of the parents sides.
    sides = (parent1.sides - parent2.sides) + (int)randomGaussian()*dna.mutation/2 + (int)random(-1, 1);
    if (sides<3) {
      sides = 2 + dna.mutation;
    }
    //    setSides(sides);

    //radius are a combination of the parents radius.
    radius = (parent1.radius+parent2.radius)/2;
    //    setRadius(radius);

    //etnicity - if the etnicity of the parents is the same, the child gets the same etnicity (language) otherwise it will be a concatenated string (A+A+AE etc...)

    //if (parent1.etnicity==parent2.etnicity) {
    //  etnicity =  parent1.etnicity;
    //} else {
      etnicity = (parent1.etnicity+parent2.etnicity);
    //}
  }

  /*---------------set NEW VOICE---------------------*/

  public void setThisVoice() {

    //limiting the range of modul and carrier
    int carrierRange = intoRange(PApplet.parseInt(random(parent1.sides*dna.mutation)), 20, 800);
    int modulRange = intoRange(PApplet.parseInt(random(parent2.sides*dna.mutation)), 20, 800);

    //    amp = map (dna.lifespan, 1,3000,0.0,0.5);

    // fma modulation for children with 2 etnicity letters (e.g. AE, BB etc..)
    if (etnicity.length()<2) {
      carrier = new Oscil( Frequency.ofPitch(parent2.etnicity + Integer.toString(carrierRange)), amp, Waves.TRIANGLE );//SETTING THE CARRIER

      /* // setup for the fm modulation W.i.p.
       childModul = new Oscil( Frequency.ofPitch(parent1.etnicity + Integer.toString(modulRange)), 0.5, Waves.SINE ); //setting the modulator
       childModul.offset.setLastValue(300);  //limiting the offset
       childModul.offset.setLastValue(this.sides*this.radius);
       childModul.patch(carrier.frequency);  //patching the 2 Oscil
       modulate(carrier);//fucntion for the modulation of the fm
       voice  = new Voice(carrier); ///create an object Voice with the Oscil carrier that is what we will hear
       */

      // if the etnicity comprehends more letters (e.g. BCB, ABD, etc...) use the sequencer
    } else { 
      setChildSpeech(80);
    }
  }


  /*---------------set NEW VOICE sequencer ---------------------*/

  public void setChildSpeech( int tempo ) {
    //    //    /*

    voice.out.setTempo( tempo );
    voice.out.pauseNotes();

    int etnicityLength = etnicity.length();
    for (int i=0; i< etnicityLength; i++) {
      char note = etnicity.charAt(i);

      //limiting the values of the octave 
      //      int freqLimit = (int)map(random(sides-dna.mutation), 0, 100,4,8);
      //      int octaveRange = intoRange((parent2.sides + parent1.sides) / dna.mutation, 2, 8);
      int octaveRange = (int)map((parent2.sides + parent1.radius) / dna.mutation, 0, 100, 2, 32);

      String octave = Integer.toString(octaveRange);

      //startTime, duration, frequency
      voice.out.playNote(i, sides/radius, note + octave );
      println(note + octave);
    }
    //     */
  }

  /*---------------modulate for FM ---------------------*/

/*
  // modulate function helps for the fm modulation //not used in this version
  void modulate(Oscil fm)
  {
    float modulateAmount = map( location.x+1, 0, width, 220, 1 );
    float modulateFrequency = map( location.y+1, 0, height, 0.1, 100 );
    //    float modulateAmount = map( mouseY, 0, height, 220, 1 );
    //    float modulateFrequency = map( mouseX, 0, width, 0.1, 100 );

    fm.setFrequency( modulateFrequency );
    fm.setAmplitude( modulateAmount );
  }
  */

  /*----------------TALK-----------------*/

  public void talk() {
    println("--------------TALK!");
    //    /*
    if (etnicity.length()<2) {
      carrier.patch(voice.out);
    } else { 
      //     */
      voice.out.resumeNotes();
    }
  }
  /*----------------silence-----------------*/

  //  /*
  public void silence() {
    //    super.silence();
    carrier.unpatch(voice.out);
    //    childModul.unpatch(voice.out);
  }

  //  */
  /*---------------set PARENTS---------------------*/

  //let's define my parents
  public void setParents(Creature pa1, Creature pa2) {

    parent1 = pa1;
    parent2 = pa2;
  }

  /*---------------DEFINE SEX---------------------*/

  //let's define my sex - summing the values of male and female of the parents. The higher will be the sex of the child
  public String defineChildSex() {
    sexPercMale = parent1.dna.mySexPerc[0] +  parent2.dna.mySexPerc[0];
    sexPercFem = parent1.dna.mySexPerc[1] +  parent2.dna.mySexPerc[1];

    // check what's the higher value
    if (sexPercMale>sexPercFem + random(dna.mutation)) {
      dna.sex = dna.mySex[0];
    } else if (sexPercMale<sexPercFem - + random(dna.mutation) ) {
      dna.sex = dna.mySex[1];
    }

    //if the value are equal the sex is defined randomly
    if (sexPercMale==sexPercFem) {
      dna.sex = dna.mySex[(int)random(0, dna.mySex.length)];
    }

    return dna.sex;
  }

  /*---------------limit function ---------------------*/


  ////// limit function/////quick fucntion that allows me to limit some value;

  private int intoRange(int value, int min, int max) {
    return Math.min(Math.max(value, min), max);
  }
}
class Creature implements Silence {
  //declaring the Dna
  DNA dna;
  // declaring the creatures with which the creature will interact
  Creature friend, neighbour, partner;

  // this will store a story of the children of each creature
  ChildCreature child;
  ArrayList <ChildCreature> myChild;

  // voice variables
  Voice voice;
  Oscil carrier, childModul;
  Frequency voiceFreq;
  float amp;

  //physics and spatial
  PVector location;
  float x, y, z;
  float edgex, edgey;
  PVector velocity, accel, newAccel;
  float velx, vely;
  float theta, steeringForce, count, rotation, angle, halfAngle;
  float speedx, speedy, maxSpeed;
  float wandertheta;



  //physical attributes
  int sides;
  int minSides, maxSides;
  int skin;
  float radius, outRad, innerRad;
  float headx, heady;

  // voice and etnicity - this is considered as a language mostly.
  String etnicity;
  String [] myEtnicity = {
    "A", "B", "C", "D", "E", "F", "G"
  };

  //index of each creature
  String index;

  // some boolean
  boolean alive;
  boolean moving, collide;
  boolean coupled;
  boolean sexmatch, fitnessmatch, agematch, skinmatch, etnicmatch;

  //ints vars to store the creature history
  int numFriends, numPartners, numChildren, numNeighbours;

  /*------------------------------------------------*/

  Creature() {

    //physical
    dna = new DNA();
    myChild = new ArrayList <ChildCreature>();
    etnicity = myEtnicity[(int)random(0, myEtnicity.length)];

    //physical attributes
    minSides = 3; //min num sides first generation
    maxSides = 19; //max num sides first generation
    sides = (int)abs(randomGaussian()*(noise(minSides, maxSides)*random(minSides, maxSides))); //this should set the average num side from min to max
    if (sides<=2) {
      sides=minSides; //if num sides <=2 let's make the num sides  = 3
    }
    
    radius = random(5, 40);
    outRad = radius/cos(TWO_PI / sides);
    innerRad = radius/2;
    
    if (dna.mutation<=2) {
      skin = color (random(255), random(255), random(255));// here I am creating an exception in skin. If the mutation val is =<2 then the skin will be random.
    } else {
      //otherwise crete skin
      
      String colorStr ="" + etnicity + str(PApplet.parseInt(radius)) + str(sides) + str(PApplet.parseInt(dna.mutation));
      println ("-----mio colore stringa " + colorStr + " - " + str(colorStr.length()));
      
      if (colorStr.length()%2 == 0){
      colorStr = colorStr + etnicity;
//      skin = color (unhex(colorStr));// range of orange color

      } else {
      
      skin = color (random(255), random(255), random(255));// here I am creating an exception in skin. If the mutation val is =<2 then the skin will be random.

      }      
      
    }
          println ("-----mio colore vero " + str(skin));


    //physics
    accel = new PVector(0, 0);
    velx = randomGaussian();
    vely = randomGaussian();
    velocity = new PVector(velx, vely);
    maxSpeed = sqrt(radius);
    //    fast=false;
    wandertheta = 0;
    steeringForce = maxSpeed/(radius*sides*dna.mutation);

    //spatial
    x = random(radius*4, width - radius*4);
    y = random(radius*4, height - radius*4);
    location = new PVector(x, y);
    edgex = x-radius;
    edgey = y-radius;

    //boolean
    coupled = false;
    collide = false;
    sexmatch = false;
    fitnessmatch = false;
    agematch = false;
    skinmatch = false;
    etnicmatch = false;
    alive = true;

    index = "0";

    //historic
    numChildren = 0;
    numFriends = 0;
    numPartners = 0;
    numNeighbours = 0;
    child = null;
    friend = null;
    partner = null;
    neighbour = null;
    childModul = null;

    //voice

    int freqLimit = (int)map(random(sides-dna.mutation), 0, 100, 4, 8 ); //limiting the freq
    amp = map (dna.lifespan, 1, 3000, 0.0f, 0.1f); //defining the amp according to the lifespan

    //conditioning the single Oscillator to the lenght of the etnicity
    if (etnicity.length()<2) {
      carrier = new Oscil( Frequency.ofPitch(etnicity+Integer.toString(freqLimit)), amp, Waves.SINE );
      //        carrier = new Oscil( Frequency.ofPitch(etnicity+Integer.toString(int(random(sides-dna.mutation)))), 0.8, Waves.TRIANGLE ); // old version
      //    childModul = new Oscil( Frequency.ofPitch(etnicity+Integer.toString(int(random(sides-dna.mutation)))), 0.0, Waves.TRIANGLE );  // possible for fm modulation
    }    
    voice = new Voice(carrier);
    talk(); //make them talk!
  }

  /*--------------RUN--------------------*/

  public void run() {
    update();
    borders();
    display();
  }

  /*----------------UPDATE-----------------*/

  public void update() {

    dna.lifespan--; //reducing lifespan every cycle
    checkLife(); //check if the creature is alive
    // Update velocity
    velocity.add(accel);
    // Limit speed
    velocity.limit(maxSpeed);
    location.add(velocity);
    // Reset accelerationelertion to 0 each cycle
    accel.mult(0);
    //voice
    //    modulate(childModul);
    amp = map (dna.lifespan, 1, 3000, 0.0f, 0.5f);
    setAmp(amp);

    //silencing the creatures if they are dead - R.I.P.
    if (dna.lifespan<=0) {
      silence();
    }

    //testing the encapsulaiton of the procreation in the creature itself.
    //procreation
    //    if (coupled) {
    //      procreate();
    //    }
  }

  /*----------------CHECK LIFE OF THE CREATURE-----------------*/

  // checkLife checks all the variations in the creature life e.g. lifespan and partners and children and potentially neighbours.
  public void checkLife() {
    // Check lifespan
    if (dna.lifespan<=0) {
      silence();
      dna.lifespan=0;
      alive=false;
    }

    //check partner
    //TODO
    //check children
    //TODO
    //check neigbours
  }


  /*--------------DISPLAY--------------------*/

  /*here is the function that determins the way creatures look 
   males are fully colored polygons
   females are empty colored (just borders) polygons
   herma (not used in this sketch) have both border and full color
   the gender doesn't affect the way creatures look
   
   */

  public void display() {
    theta = velocity.heading2D();
    angle = TWO_PI / sides;
    halfAngle = angle/2.0f+sin(theta);

    if (alive==true) {
      if (dna.sex== "male") {
        pushStyle();
        fill(skin);
        noStroke();
        beginShape();
        for (float a = 0; a < TWO_PI; a += angle) {
          float xp = location.x + cos(theta+a) * radius;
          float yp = location.y + sin(theta+a) * radius;
          vertex(xp, yp);
          ellipse(xp,yp, radius/dna.lifespan,radius/dna.lifespan); //little circles explode at death
          
          pushStyle();
          fill(red(skin),green(skin),blue(skin),255/sides);
          ellipse(xp,yp, dna.lifespan/(radius*sides),dna.lifespan/(radius*sides)); //little hands
          popStyle();
          xp = location.x + cos(theta+a+halfAngle) * innerRad;         //theta is the value which will affect the shape - take theta out and yo'll get just a normal polygon
          yp = location.y + sin(theta+a+halfAngle) * innerRad;
          vertex(xp, yp);
        }
        displayHead();
        endShape(CLOSE);
//        ellipse(location.x, location.y,20,20);
        popStyle();

        displayOutRadius();
        displayIndex();
      }
      if (dna.sex== "female") {
        pushStyle();
        noFill();
        stroke(skin);
        strokeWeight(random(.5f, 1));
        beginShape();
        for (float a = 0; a < TWO_PI; a += angle) {
          float xp = location.x + cos(theta+a) * radius;
          float yp = location.y + sin(theta+a) * radius;
          vertex(xp, yp);
          ellipse(xp,yp, radius/dna.lifespan,radius/dna.lifespan); //little circle explode at death

          line(xp,yp,location.x, location.y);
          xp = location.x + cos(a+halfAngle) * innerRad;
          yp = location.y + sin(a+halfAngle) * innerRad;
          vertex(xp, yp);
        }
        displayHead();
        endShape(CLOSE);
        popStyle();

        displayOutRadius();
        displayIndex();
      }    

      if (dna.sex== "herma") {
        pushStyle();
        fill(skin);
        stroke(skin);
        strokeWeight(random(.5f, 1));
        beginShape();
       for (float a = 0; a < TWO_PI; a += angle) {
          float xp = location.x + cos(theta+a) * radius;
          float yp = location.y + sin(theta+a) * radius;
          vertex(xp, yp);
          xp = location.x + cos(theta+a+halfAngle) * innerRad;
          yp = location.y + sin(theta+a+halfAngle) * innerRad;
          vertex(xp, yp);
        }
        displayHead();
        endShape(CLOSE);
        popStyle();

        displayOutRadius();
        displayIndex();
      }
    }
  }


  /*----------------POLYGON STAR-----------------------*/

  public void createPoly(float x, float y, float radius, float innerRad) {

    int sides = (int)random(19); 
    int skin = color (random(255), random(255), random(255));
    float theta = random(360%45);
    float angle = TWO_PI / sides;
    float halfAngle = angle/2.0f;
    pushStyle();
    fill(skin);
    noStroke();
    beginShape();
    for (float a = 0; a < TWO_PI; a += angle) {
      float sx = x + cos(a) * radius;
      float sy = y + sin(a) * radius;
      vertex(sx, sy);
      sx = x + cos(a+halfAngle) * innerRad;
      sy = y + sin(a+halfAngle) * innerRad;
      vertex(sx, sy);
    }
    endShape(CLOSE);
    popStyle();
    popMatrix();
  }



  /*----------------MOVE-----------------------*/

  public void move() {
    moving = true;
    float wanderR = radius;         // Radius for our "wander circle"
    float wanderD = radius*sides;         // Distance for our "wander circle"
    float change = 0.3f;
    wandertheta += random(-change, change);     // Randomly change wander theta

    // Now we have to calculate the new location to steer towards on the wander circle
    PVector circleloc = velocity.get();    // Start with velocity
    circleloc.normalize();            // Normalize to get heading
    circleloc.mult(wanderD);          // Multiply by distance
    circleloc.add(location);               // Make it relative to boid's location

      float h = velocity.heading2D();        // We need to know the heading to offset wandertheta

    PVector circleOffSet = new PVector(wanderR*cos(wandertheta+h), wanderR*sin(wandertheta+h));
    PVector target = PVector.add(circleloc, circleOffSet);
    seek(target);

    // Render wandering circle, etc. 
    if (debug) drawWanderStuff(location, circleloc, target, wanderR);
  }

  /*----------------SEEK-----------------------*/

  public void seek(PVector target) {
    PVector desired = PVector.sub(target, location);  // A vector pointing from the location to the target

    // Normalize desired and scale to maximum speed
    desired.normalize();
    desired.mult(maxSpeed);
    // Steering = Desired minus Velocity
    PVector steer = PVector.sub(desired, velocity);
    steer.limit(steeringForce);  // Limit to maximum steering force
    applyForce(steer);
  }

  /*----------------FORCES-----------------*/


  public void applyForce(PVector force) {

    if (!fast) {
      // We could add mass here if we want A = F / M
      //mass is num sides + radius
      force = PVector.div(force, (radius*sides));//this is the vector you need to make the mass working
      accel.add(force); //comment this and uncomment the two lines below if you want the mass working
    } else {
      accel.add(force); //comment this and uncomment the two lines below if you want the mass working
    }
  }

  /*----------------FREEZE-----------------------*/

  public void freeze() {

    //    theta+= speedx/10;
    PVector velZero = new PVector(0, 0);
    setVel(velZero);

    //uncomment these 2 lines if you want the creatures to stop completely!
    //    steeringForce=0;
    //    theta=0;
  }


  /*----------------COLLISION-----------------------*/
  public boolean colliding(Creature c) {

    float distance = location.dist(c.location)  ;
    if (distance <= radius + c.radius  ) { //if collide
      collide=true; //collide true
      numPartners++;  //increase num partners
      return true;
    } else {
      collide=false;
      return false;
    }
  }

  /*----------------TALK-----------------*/


  public void talk() {
    // voice
    carrier.patch (voice.out);
  }

  /*----------------silence-----------------*/


  public void silence() {
    carrier.unpatch(voice.out);
    //    childModul.unpatch(voice.out);
  }


  /*---------------set NEW VOICE---------------------*/

  public void setThisVoice() {
    //TODO
  }



  /*---------------MODULATE OSCIL ---------------------*/

  //this is a work in progress ti implement the fm modulation
  /*
  void modulate(Oscil wave)
   {
   float freq = map( location.x+1, 0, width, 20, 880 );
   float amp = map( location.y+1, 0, height, .5, 0 );
   float modulateAmount = map( mouseY, 0, height, 220, 1 );
   float modulateFrequency = map( mouseX, 0, width, 0.1, 100 );
   
   wave.setFrequency( freq );
   wave.setAmplitude( amp );
   }
   */

  /*----------------PROCREATE-----------------*/
  // this was an old attempt. didn't work - I wanted to encapsulate the procreation into the creature.
  /*
      void procreate() {
   child = new ChildCreature();
   child.setParents(this, partner);
   child.setDNA();
   myChild.add(child); // adding the child to the vector
   }
   
   */

  /*----------------stage wrapping-----------------*/

  // Wraparound the stage -  creatures will go from side to side
  public void borders() {
    if (location.x < -radius) location.x = width;
    if (location.y < -radius) location.y = height;
    if (location.x > width) location.x = -radius;
    if (location.y > height) location.y = -radius;
  }


  /*-------------this is the edge of the creature--------------*/

  public float borderX() {

    return edgex;
  }

  public float borderY() {

    return edgey;
  }

  /*------------AREA-------------*/
  //eventually to calculate the area of the creature
  public float area() {
    return (pow(radius, sides)*sin(PI/sides))/2;
  }

  /*---------------limit function ---------------------*/

  /*
    ////// limit function/////quick fucntion that allows me to limit some value;
   
   private int intoRange(int value, int min, int max) {
   return Math.min(Math.max(value, min), max);
   }
   */

  /*-----------DEBUG-----------------*/

  //inf on index, location and velocity
  public void displayIndex() {
    if (debug) {

      fill(0, 200, 200);
      textSize(radius+10);
      text(index+"/ "+str(theta), location.x, location.y);

      fill(0, 100, 200);
      textSize(13);
      text("velocity "+str(velocity.x*velocity.y), location.x+radius, location.y+10);
      text("maxSpeed "+str(maxSpeed), location.x+radius, location.y+20);
      text("mass "+str(fast), location.x+radius, location.y+30);
      //      text("num child "+str(child), location.x+radius, location.y+40);
    }
  }


  /*---------------some fancy debug of physical attribute you don't really need-------------*/


  public void displayOutRadius() {
    if (debug) {
      noFill();
      //    ellipse(x, y, outRad, outRad);
      stroke(160);
      ellipse(location.x, location.y, radius*2+(radius/4), radius*2+(radius/4));
    }
  }


  public void displayHead() {
    if (head) {
      headx = location.x + cos(theta + TWO_PI / sides) * radius;
      heady = location.y + sin(theta + TWO_PI / sides) * radius;
      ellipse(headx, heady, 8, 8);
    }
  }


  /*-------------  setters & getters  -------------*/


  //setters
  public void setX(float xPos) {

    location.x = xPos;
  }
  public void setY(float yPos) {

    location.y = yPos;
  }

  public void setLoc(PVector newLocation) {

    location = newLocation;
  }

  public void setVel(PVector newVelocity) {

    velocity = newVelocity;
  }

  public void setAccel(PVector acceleration) {

    accel = acceleration;
  }

  /// set partner, friend, neighbour

  public void setFriend(Creature f) {

    friend = f;
  }

  public void setPartner(Creature p) {

    partner = p;
  }

  public void setNeighbour(Creature n) {

    neighbour = n;
  }


  //set physical stuff: sides, skin, radius, etnicity

  public void setSides(int n) {

    sides = n;
  }

  public void setSkin(int newColor) {

    skin = newColor;
  }

  public void setRadius(float rad) {

    radius = rad;
  }

  public void setEtnicity(String newEtn) {

    etnicity = newEtn;
  }

  public void setAmp(float a) {

    amp = a;
  }




  ////////////getters


  public float getX() {

    return location.x;
  }
  public float getY() {

    return location.y;
  }
  public float getVelx() {

    return velocity.x;
  }
  public float getVely() {

    return velocity.y;
  }
  public PVector getAccel() {

    return accel;
  }


  /// //get physical stuff: sides, skin, radius, etnicity

  public int getSides() {

    return sides;
  }

  public int getSkin() {

    return skin;
  }

  public float getRadius() {

    return radius;
  }

  public String setEtnicity() {

    return etnicity;
  }
}
// this is the basic DNA class where all the basic elements of the creature are set up.

public class DNA {


  String sex, gender;
  String [] mySex = {
     "male", "female" /*, "herma"*/
  };
  String [] myGender = {
    "hetero", "homo", "bi", "trans"
  };
  int [] myGenderPerc = {
    0, 0, 0, 0
  };
  //the nuber of elements in this array should be = to the number of sex we generate. In our case 2- remember to change this if you use other extra type of sex.
  int [] mySexPerc = {
    0, 0
  };

  int genderType, sexType;

  // variables to control the variation and the reproduction.
  int mutation;
  int lifespan; 
  int timeMating;


  DNA() {

    //sex = mySex[(int)random(0, mySex.length)]; //old way random generation of sex
    //define Sex using a percentage algorithm
    defineSex();
    sex = mySex[sexType];
    //define Gender using a percentage algorithm
    defineGender();
    gender = myGender[genderType];
    //random lifeSpan
    lifespan = PApplet.parseInt(random(randomGaussian()*1, (30*100)));
    //random mutation factor
    mutation = PApplet.parseInt(random(1, 3) + noise(1, randomGaussian()*2)*5);
    //this is the time which conditions the procreation
    timeMating = lifespan/mutation;
  }


  public int defineGender() {
    int gender;
    //// assign 1 int randomly to the 4 indeces of the array (random percentage)
    for (int i=0; i<100; i++) {
      myGenderPerc[(int)random(0, myGender.length)]++; 
      gender = i;
    }  
    //    println("gender percentage", myGenderPerc[0], myGenderPerc[1], myGenderPerc[2], myGenderPerc[3]); //prints percentage of gender

    // ----
    //find the largest value of the array that I just populated and get the index of the array
    int largest = myGenderPerc[0];
    for (int i = 1; i < myGenderPerc.length; i++) {
      if ( myGenderPerc[i] >= largest ) {
        largest = myGenderPerc[i];
        genderType = i;
      }
    }

    //    genderType = max(myGenderPerc);
    //    println(genderType);

    return genderType;
  }

  ///define sex

  public int defineSex() {
    int sex;
    //// assign 1 int randomly to the 4 indeces of the array (random percentage)
    for (int i=0; i<100; i++) {
      mySexPerc[(int)random(0, mySex.length)]++; 
      sex = i;
    }  
    //    println("sex percentage", mySexPerc[0], mySexPerc[1], mySexPerc[2], mySexPerc[3]); //prints percentage of gender

    // ----
    //find the largest value of the array that I just populated and get the index of the array
    int largest = mySexPerc[0];
    for (int i = 1; i < mySexPerc.length; i++) {
      if ( mySexPerc[i] >= largest ) {
        largest = mySexPerc[i];
        sexType = i;
      }
    }
    //if the values are equal then go random.
    if (mySexPerc[0]==mySexPerc[1]) {
      sexType = PApplet.parseInt(random(0, 1));
    }

    //    genderType = max(mySexPerc);
    //    println(sexType);

    return sexType;
  }

  ////////////// setters & getters ////////////////


  public void setSexPerc(int malePerc, int femalePerc ) {
    mySexPerc[0] = malePerc;
    mySexPerc[1] = femalePerc;
  }


  public int getSexPerc(int a) {
    // a should be either 1 or 0;
    return  mySexPerc[a];
  }

  public int getGenderPerc(int a) {
    // a should be either 1 or 0;
    return  myGenderPerc[a];
  }

  public String getGender() {
    return  gender;
  }
}
public interface Silence {

  public void silence();
}
public class Voice {
  Minim minim;
  AudioOutput out;

  // setup the constructor for notes
  Voice() {
    // initialize the minim and out objects
    minim = new Minim( this );
    out   = minim.getLineOut();
  }


  // setup the constructor for fm
  Voice(Oscil carrier, Oscil modulator) {
    // initialize the minim and out objects
    minim = new Minim( this );
    out   = minim.getLineOut();
  }

  // setup the constructor for single oscillator
  Voice(Oscil oscil) {
    // initialize the minim and out objects
    minim = new Minim( this );
    out   = minim.getLineOut();
  }
}
  public void settings() {  size(800, 800);  smooth(); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "manymals_Master_v02" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
