/*
//================================================================================================================================================//
 //==================================================== M A N Y M A L S  V.02 ====================================================================//
 //================================================================================================================================================//
 //Author: 
 //Antonio Daniele
 //EXPLORING SOCIAL BEHAVIOUR AND IDENTITY THROUGH GENETIC ALGORITHMS.
 //End of term assignment: Programming for Artists ::: MFA Computational arts 2014 -15
 
 ////////////////////////////////////////////////////////////////////////
 
 Aim
 ---
 The aim is to experiment with genetic algorithms in order to explore the possibilities of relations between creatures that simulate a behaviour.
 The work is also a way for me to engage with some more advanced Java and generative systems.
 This work is meant to be a starting point for exploring these subjects.
 
 Process
 -------
 I started, as usual, from a vision, an image that I had in mind.
 At first I approached this project with almost no notions of genetic algorithms. I wanted to see if I could get my own way by using some logic.
 In fact, probably, this project doesn't use the common variables of GA (fitness, mutation etc) as many other projects use.
 My idea was mostly to rely on my logic leaving open the possibility to explore different variations.
 Once I set up the core of the program I started reading some documents on GA and checked other examples that I confrontated with mine.
 I noticed that more or less the approach was similar and I then optimised my code according to what was more useful.
 For instance, after my first attempts on moving the creatures, although good, they were eventually highly influented by the Shiffman's
 Nature of code examples on vector forces. 
 This is the only part of code that Is not completely original. Together with the function to create polygons, by knowing the radius.
 The rest of the code is from my own head and there are evident margins for improvements.
 In few words the process I followed was sticking to the main image that I had in mind according to which the creatures had to represent human individuals
 and simulating some sort of social behaviour. And of course procreating.
 I always imagined these creatures with the ability of 'speaking'. In fact in my idea the sound they produce is a proper language based on their place of birth (etnicity var).
 The language evolves with the creatures so that when they pass 1 generation they can start producing a sequence of notes rather than a single pronlonged sound.
 
 The code counts 3 main classes
 DNA - that contains the basic data of the creature (sex, gender, lifespan and mutation)
 Creature - this is the basic creature which contains the physical features, behaviour and voice
 ChildCreature - this is a child class of Creature. The choice of having a subclass is because I wanted the child to have different features like the language.
 
 The class Voice is an easier way to call the minim library.
 Finally, SIlence is a work in progress Interface that I would like to use in a future development.
 
 
 Comments
 --------
 The program is working well and as expected.
 I managed to create a good variety of possibilities for language and populations.
 There are massive margins of improvement for this code.
 Not only from an aesthetic point of view but also for efficiency and functionalities.
 I would like to port this on a mobile app or a web app for instance.
 Overall I think I am happy with this project as I acheived the pre-fixed results and overcame many issues
 such as the good implementation of the sound (which caused many problems) or controlling the birth of new children.
 
 At the moment the project is in a very beta phase. It is all very experimental.
 For instance the "etnicity" variable has been strongly discussed as it involves some idea that extends the language. Etnies are more than just language and in fact this
 is something that I would like to introduce in a further version. Maybe the possibilities to create different behaviours according to "cultures".
 Same it can be said for the gender and sex dynamics.
 At the moment the creatures reproduce following the main matingRules(). However I would like to condition  the creatures' mating behaviour according to factors such as
 the fitness or the etnicity value or other social variables like prejudice etc.
 
 Evaluation
 ----------
 Bugs: Very rarely the sound keeps on going even after the death of all the animals. This usually happens when there are a lot of repeted press of letter 'r'.
 I didn't find a way to kill the sound for good, so I had to condition that to the amplitude and the lifespan. 
 Extensions:None
 
 Keybord Commands
 ----------
 r       - reset and repopulate the universe
 d       - debug info 
 l       - if debug info activated, it shows the construction lines of the movement forces
 f       - speeds up the creatures or slow them down. It actually gives the creatures a mass. (if the creature is fast already this will affect the child)
 s       - save a screenshot
 
 
 Pseudocode
 ----------
 Here after there is a pseudocode for one of the main functions of the program. I am not going to explain the matingRules() method as it is just long and boring.
 I think the process to build sex and gender is more fun. It is in the DNA class.
 
 Aim is getting out a random gender for each creature. The gender is determined by calculating 4 random percentage up to 100%.
 The higher value will be the determined gender. The same applies to sex. This choice is a conceptual choice as well as practical.
 Creatures like us are neither 100% male or female, they have a dynamic balance of these values.
 
 1st part - distribute 100 in 4 boxes.
 1 - I create an array1 of String with n elements. One for each gender/sex
 2 - I create an array2  of Int with the same num of elements of the String array. The elements here have value 0;
 3 - I then need to have 2 variables. 1 String var to store the value of the final gender/sex.
 4 - The other variable is an Int and will store the index of the array with higher percentage. 
 5 - let's randomly distribute the number 100 in 4 elements of the array2 (int)
 6 - create a for loop which iterates through the random elements of the array2. and adds 1 unit.
 in this way 100 units will be distributed randomly in the 4 elements of the array.
 
 2nd part - find the largest number in the array and get me the index of that element in the array.
 7 - take the first element and store it into a var called largest
 8 - iterate all the elements in the array (go from 1 to array.length to avoid exceeding)
 9 - if the second element is higher than the first then it become "largest"
 10 - proceed like this for all the elements (for loop)
 11 - once found the largest number in the array, give me back the index (that will be the int i of the for loop) 
 
 3rd part 
 12 - assign the index just found to determin the sex/gender in the String array1
 
 
 
 */

//================================================================================================================================================//
//==================================================== M A N Y M A L S  V.00 ====================================================================//
//================================================================================================================================================//


// import everything necessary to make sound. (Minim Library)
import ddf.minim.*;
import ddf.minim.ugens.*;


/*-----------GLOBAL VARIABLES-----------------*/

int numCreatures; //initial num of creatures in the Universe

//boolean collide, sexmatch, fitnessmatch, agematch, skinmatch, etnicmatch; //TODO
ArrayList <Creature> myCreatures;
boolean debug, vectorLines = false;
boolean head, fast = true;
boolean startTouch, endTouch;
int touchcount;  //counter
int divider = 0;  // used to control the num of touch. obsolete now.
//Silence silence; // Test for interface

//save image vars//
int imageCounter=0;
int d = day();    // Values from 1 - 31
int m = month();  // Values from 1 - 12
int y = year();   // 2003, 2004, 2005, etc.
int sec = second();  // Values from 0 - 59
int min = minute();  // Values from 0 - 59
int h = hour();    // Values from 0 - 23
//end save image vars//

/*-----------SETUP-----------------*/


void setup() {
  
 //use random seed to generate always the same sequence
//  randomSeed(150);

  startTouch = false;
  endTouch = false;
  touchcount = 0;
  numCreatures = 7*2;
  
  size(800, 800);
  smooth();
  CreatureSetup();
}

/*-----------DRAW-----------------*/


void draw() {

  //use random seed to generate always the same sequence
//  randomSeed(150);

  background(250);
  //println(myCreatures.length);
  populate();
  checkContact();

  //when there are no creatures there is a message;
  restartMessage();
}



/*-----------CHECK CONTACT-----------------*/

void checkContact() {
  //iterating the creatures like in a matrix
Outer:
  for (int i = 0; i < myCreatures.size (); i++)  
  {  
    for (int j = i + 1; j < myCreatures.size (); j++)  
    {  
      if (myCreatures.get(i).colliding(myCreatures.get(j)) && myCreatures.get(j).colliding(myCreatures.get(i)) ) {

        /* this block is a work in progress to create more social behaviour.
         WHen the creatures first meet they become friends. If they stay for long enough become partners and then they reproduce. 
         at the moment it is not working properly. Need some job on it.
         
         myCreatures.get(i).setFriend(myCreatures.get(j));
         myCreatures.get(j).setFriend(myCreatures.get(i));
         
         if (myCreatures.get(i).collide==true) {
         myCreatures.get(i).numFriends++;
         myCreatures.get(j).numFriends++;
         }
         
         if (myCreatures.get(i).numFriends>=myCreatures.get(i).dna.timeMating) {
         myCreatures.get(i).numFriends=0;
         myCreatures.get(i).numPartners++;
         myCreatures.get(j).numPartners++;
         }
         */

        //now check the mating Rules
        matingRules();
        break Outer;
      }
    }
  }
}




/*------------POPULATE------------------*/


void populate() {

  for (int i = 0; i<myCreatures.size (); i++) {

    myCreatures.get(i).run();
    myCreatures.get(i).move();
    myCreatures.get(i).index=str(i);

    //when they are dead just remove them from the list
    if (myCreatures.get(i).alive==false) {
      myCreatures.remove(i);
    }
  }
}

/*------------CREATURE SETUP------------------*/

void CreatureSetup() {
  myCreatures = new ArrayList <Creature>();
  for (int i = 0; i<numCreatures; i++) {

    myCreatures.add (new Creature()); // creating all the creatures

    println( myCreatures.get(i).dna.sex, myCreatures.get(i).dna.gender, myCreatures.get(i).etnicity, myCreatures.get(i).dna.lifespan, i);
  }
}

/*------------CREATURE KILL ALL------------------*/

void killAll() {
  for (int i = 0; i<myCreatures.size (); i++) {
    myCreatures.get(i).silence(); //silencing all the creatures

    println( "new size is "+ myCreatures.size());
  }

  myCreatures.clear();
}

/*--------------- MATING RULES ---------------------*/
//this is the main function that determins which creatures can meet and eventually reproduce according to sex and gender.
void matingRules() {
Outer:
  for (Creature one : myCreatures) {
    one.sexmatch = false;
    for (Creature other : myCreatures) {
      if (one != other && one != one.child && other != other.child && one.colliding(other) && other.colliding(one)) {
        if (  //start mega IF

        //hetero//
        (one.dna.sex=="male" && one.dna.gender=="hetero") && (other.dna.sex=="female" && other.dna.gender=="hetero") ||

          //homo male//
        (one.dna.sex=="male" && one.dna.gender=="homo") && (other.dna.sex=="male" && other.dna.gender=="homo") ||
          (one.dna.sex=="male" && one.dna.gender=="homo") && (other.dna.sex=="male" && other.dna.gender=="bi") ||
          (one.dna.sex=="male" && one.dna.gender=="homo") && (other.dna.sex=="male" && other.dna.gender=="trans") ||
          //homo female//
        (one.dna.sex=="female" && one.dna.gender=="homo") && (other.dna.sex=="female" && other.dna.gender=="homo") ||
          (one.dna.sex=="female" && one.dna.gender=="homo") && (other.dna.sex=="female" && other.dna.gender=="bi") ||
          (one.dna.sex=="female" && one.dna.gender=="homo") && (other.dna.sex=="female" && other.dna.gender=="trans") ||

          //trans male//
        (one.dna.sex=="male" && one.dna.gender=="trans") && (other.dna.sex=="male" && other.dna.gender=="trans") ||
          (one.dna.sex=="male" && one.dna.gender=="trans") && (other.dna.sex=="female" && other.dna.gender=="trans") ||
          (one.dna.sex=="male" && one.dna.gender=="trans") && (other.dna.sex=="male" && other.dna.gender=="bi") ||
          (one.dna.sex=="male" && one.dna.gender=="trans") && (other.dna.sex=="male" && other.dna.gender=="homo") ||
          //trans female//
        (one.dna.sex=="female" && one.dna.gender=="trans") && (other.dna.sex=="female" && other.dna.gender=="trans") ||
          (one.dna.sex=="female" && one.dna.gender=="trans") && (other.dna.sex=="male" && other.dna.gender=="trans") ||
          (one.dna.sex=="female" && one.dna.gender=="trans") && (other.dna.sex=="female" && other.dna.gender=="bi") ||
          (one.dna.sex=="female" && one.dna.gender=="trans") && (other.dna.sex=="female" && other.dna.gender=="homo") ||

          //bi male//
        (one.dna.sex=="male" && one.dna.gender=="bi") && (other.dna.sex=="male" && other.dna.gender=="bi") ||
          (one.dna.sex=="male" && one.dna.gender=="bi") && (other.dna.sex=="male" && other.dna.gender=="homo") ||
          (one.dna.sex=="male" && one.dna.gender=="bi") && (other.dna.sex=="female" && other.dna.gender=="hetero") ||
          (one.dna.sex=="male" && one.dna.gender=="bi") && (other.dna.sex=="female" && other.dna.gender=="bi") ||
          (one.dna.sex=="male" && one.dna.gender=="bi") && (other.dna.sex=="male" && other.dna.gender=="trans") ||
          //bi female//
        (one.dna.sex=="female" && one.dna.gender=="bi") && (other.dna.sex=="female" && other.dna.gender=="bi") ||
          (one.dna.sex=="female" && one.dna.gender=="bi") && (other.dna.sex=="female" && other.dna.gender=="homo") ||
          (one.dna.sex=="female" && one.dna.gender=="bi") && (other.dna.sex=="male" && other.dna.gender=="hetero") ||
          (one.dna.sex=="female" && one.dna.gender=="bi") && (other.dna.sex=="male" && other.dna.gender=="bi") ||
          (one.dna.sex=="female" && one.dna.gender=="bi") && (other.dna.sex=="female" && other.dna.gender=="trans") 



        ) { //end mega IF ---->

          //setting sexmatch
          one.sexmatch = true;
          other.sexmatch = true;
          //setting coupled
          one.coupled = true;
          other.coupled = true;

          //the creatures stop and start knowing each other
          one.freeze();
          other.freeze();

          //debug info on the meeting (press key 'd')
          matingInfo();

          //limiting the procreation to timing conditioned by the dna
          if (one.numPartners%one.dna.timeMating==0 || other.numPartners%other.dna.timeMating==0 ) {
            //setting partners
            one.setPartner(other);
            other.setPartner(one);
            //finally procreate
            procreate(one, other);
          }
          break Outer;
        }
      }
    }
  }
}

/*--------------- MATING INFO (debug) ---------------------*/


void matingInfo() {

  if (debug) {
    for (Creature one : myCreatures) {
      for (Creature other : myCreatures) {
        if (one != other && one.colliding(other)) {

          //display info on stage//
          pushMatrix();
          int rectCoord = 120;
          translate(0, height-rectCoord);
          fill(255, 255, 255);
          noStroke();
          rect(0, 30, width, rectCoord);
          fill(0, 100, 200);
          textSize(12);
          String oneInfo = (one.dna.sex + " " + one.dna.gender + " " + one.etnicity);
          text(oneInfo, 10, 50);
          text("meets", 10, 70);
          String otherInfo = (other.dna.sex + " " + other.dna.gender + " " + other.etnicity);
          text(otherInfo, 10, 90);
          popMatrix();

          //println
          //        println("touchcount " + touchcount);
          //        println("sexmatch!");
          //        print (one.dna.sex, one.dna.gender, one.etnicity);
          //        print (" meets ");
          //        println(other.dna.sex, other.dna.gender, other.etnicity);
        }
      }
    }
  }
}

/*---------------PROCREATE---------------------*/
//this function procreates the new creatures.
void procreate( Creature parent1, Creature parent2) {

  ChildCreature child;
  child = new ChildCreature(parent1, parent2);

  myCreatures.add (child); // creating all the creatures
  parent1.myChild.add (child); // adding to the list of the parent 1 child
  parent2.myChild.add (child); // adding to the list of the parent 1 child
}



/*------------KEY COMMANDS-------------------*/


void  keyPressed() {

  //reset
  if (key == 'r') {
    killAll();
//    CreatureSetup();
//    populate();
  }

  //debug
  if (key == 'd') {
    debug = !debug;
  }

  //display head
  if (key == 'h') {
    head = !head;
  }

  //display vector debug -- it workg sonly with debug activated
  if (key == 'l') {
    vectorLines = !vectorLines;
  }

  // trigger the speed of the creatures (according to their mass)
  if (key == 'f') {
    fast=!fast;
  }


  //saving files
  if (key == 's' ) {
    imageCounter+=1;
    save("screenshots_"+d+m+y+"/manymals_"+imageCounter +"_"+d+m+h+min+sec + ".jpg");
  }
}

void keyReleased(){
  if (key == 'r') {
    killAll();
    CreatureSetup();
    populate();
  }

}

/*------------restart Message-------------------*/


void restartMessage() {
  //restart message at the end of the game
  if (myCreatures.size()<=0) {
    fill(0, 0, 0, 30);
    noStroke();
    randomPolygon(width/2, height/2, random(50), (int)random(10));

    fill(0);
    textSize(13);
    String introMess = "press r to populate the universe!";
    text(introMess, width/2 - textWidth(introMess)/2, height/2);
  }
}

void randomPolygon(float x, float y, float radius, int npoints) {
  float angle = TWO_PI / npoints;
  beginShape();
  for (float a = 0; a < TWO_PI; a += angle) {
    float sx = x + cos(a) * radius;
    float sy = y + sin(a) * radius;
    vertex(sx, sy);
  }
  endShape(CLOSE);
}


/*------------DEBUG info-------------------*/


void printData() {

  //  println( myCreatures[i].dna.sex, myCreatures[i].sides, 
  //  myCreatures[i].dna.gender, myCreatures[i].dna.etnicity, 
  //  "area", myCreatures[i].area());
  for (int i = 0; i<myCreatures.size (); i++) {

    print( myCreatures.get(i).dna.sex + " ");
    print( myCreatures.get(i).dna.gender + " ");
    print( myCreatures.get(i).etnicity + " ");

    //  print( myCreatures[i].sides + " ");
    //  print( myCreatures[i].radius + " ");
    //  print( myCreatures[i].index + " ");
    //  print( myCreatures[i].area + " ");
  }
}

// A method just to draw the circle associated with wandering
void drawWanderStuff(PVector location, PVector circle, PVector target, float rad) {
  if (vectorLines) {
    stroke(0); 
    noFill();
    ellipseMode(CENTER);
    ellipse(circle.x, circle.y, rad*2, rad*2);
    ellipse(target.x, target.y, 4, 4);
    line(location.x, location.y, circle.x, circle.y);
    line(circle.x, circle.y, target.x, target.y);
  }
  displayInfo();
}


void displayInfo() {

  for (int i = 0; i<myCreatures.size (); i++) {

    if (debug) {
      fill(0, 100, 200);
      textSize(13);
      String info = (myCreatures.get(i).dna.sex + " "
        + myCreatures.get(i).dna.gender + " "
        + myCreatures.get(i).etnicity + " "
        + "lifespan " + myCreatures.get(i).dna.lifespan  + ", "
        + "mutation " + myCreatures.get(i).dna.mutation  + ", "

        //        + myCreatures.get(i).alive  + ", "
      //      + "friends " + myCreatures.get(i).numFriends  + ", "
      + "partners " + myCreatures.get(i).numPartners  + ", "
        //      + myCreatures.get(i).dna.mySexPerc[0] + ", "
      //      + myCreatures.get(i).dna.mySexPerc[1] + ", "
      + "amp " + myCreatures.get(i).amp + ", " //amplitude of the Oscil
      + "index " + str(i)); //index of the  creature in the arraylist

      text(info, 10, 20+20*i);
      println( );
    }
  }
}